//$Id: Entity.java,v 1.1 2007-2-9 下午09:41:09 chaostone Exp $
/*
 * Copyright c 2005-2009
 * Licensed under GNU  LESSER General Public License, Version 3.
 * http://www.gnu.org/licenses
 * 
 */
/********************************************************************************
 * @author chaostone
 * 
 * MODIFICATION DESCRIPTION
 * 
 * Name           Date          Description 
 * ============         ============        ============
 *chaostone      2007-2-9         Created
 *  
 ********************************************************************************/

package org.beangle.model;

import java.io.Serializable;

/**
 * 实体类接口
 * 
 * @author chaostone
 * 
 */
public interface Entity<ID extends Serializable> extends Serializable {

	/**
	 * 返回实体的id
	 * 
	 * @return
	 */
	public ID getEntityId();
	
	/**
	 * 是否是持久化对象
	 * 
	 * @return
	 */
	public boolean saved();
	
	/**
	 * 是否是新对象
	 * 
	 * @return
	 */
	public boolean unsaved();
	
	/**
	 * 是否为值对象
	 * @deprecated
	 * @return
	 */
	public boolean isVO();

	/**
	 * 是否是持久化对象
	 * @deprecated
	 * @return
	 */
	public boolean isPO();

}
