package org.beangle.model.persist.query;

import org.beangle.commons.collection.page.Page;
import org.beangle.commons.collection.page.SinglePage;
import org.beangle.model.persist.EntityService;
import org.beangle.model.query.LimitQuery;
import org.beangle.model.query.limit.AbstractQueryPage;

public class QueryPage<T> extends AbstractQueryPage<T> {

	private EntityService entityService;

	public QueryPage(LimitQuery<T> query, EntityService entityService) {
		super(query);
		this.entityService = entityService;
		next();
	}

	public void setEntityService(EntityService entityService) {
		this.entityService = entityService;
	}

	@SuppressWarnings("unchecked")
	public Page<T> moveTo(int pageNo) {
		query.getLimit().setPageNo(pageNo);
		setPageData((SinglePage) entityService.search(query));
		return this;
	}
}
